<?
/*
This script is part of the SLIS Project initiated by the CARMI-Internet (Acadmie de Grenoble - France 38).
Ce script fait partie du projet SLIS dmarr par le CARMI-Internet (Acadmie de Grenoble - France 38).

This script have been write by Julien Dumont - copyright (C) 2001
Ce script  t crit par Julien Dumont - copyright (C) - 2001

SLIS : Serveur de communications Linux pour l'Internet Scolaire. Copyright (C) 1998-2001 Bruno Bzeznik

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details. You should have received a copy of the GNU General Public License along with this program (For example ./COPYING);
if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please send all comments and bug reports by electronic mail to: <slis@ac-grenoble.fr>
Envoyez vos suggestions et reports de bugs par e-mail  Bruno Bzeznik <slis@ac-grenoble.fr>
*/

function startHTML($titre)  // return begin of html with page title.
{
  require("../inc/themes.inc.php"); // output themes
  $val = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\n";
  $val .= "<HTML>\n";
  $val .= "<HEAD>\n";
  $val .= "<TITLE>$titre</TITLE>\n";
  $val .= "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=ISO-8859-1\">\n";
  $val .= "</HEAD>\n";
  $val .= "<BODY BGCOLOR=\"$page_bcolor\" VLINK=\"$page_vlink\" LINK=\"$page_link\">\n";
  $val .= "<FONT FACE=\"helvetica,arial\">\n";
  return($val);
}

function endHTML()   // return html page end.
{
  $val = "</FONT></BODY>\n</HTML>\n";
  return $val;
}

function image($img, $alt, $border, $imgrep)  // return html img src whith params border and alt.  - warning: imgrep must be declare in config file.
{
  $val = "<IMG SRC=\"$imgrep/$img\" ALT=\"$alt\" BORDER=\"$border\">\n";
  return $val;
}

function saut($nbs)    // return number desired of html break line "<p>"
{
  $nbsaut = "0";
  while ($nbsaut != $nbs)
    {
      $val .= "<p>&nbsp;\n";
      $nbsaut++;
    }
  return $val;
}

function starttbl($widthtbl, $border, $spa, $pad)  // return begin of simple html table whith all params.
{
 $val = "<table width=\"$widthtbl\" BORDER=\"$border\" cellspadding=\"$pad\" cellspacing=\"$spa\">\n";
 return $val;
}
function trtbl($trcolor)
{
  if ($trcolor == "0")
    {
      $val = "<TR>\n";
    }
  else
    {
      $val = "<TR BGCOLOR=\"$trcolor\">\n";
    }
  return $val;
}
function simpletd($tdin)  // return simple html td.
{
  $val = "<td>$tdin</td>\n";
  return $val;
}
function simpletd2($tdin)   // return a right align html td
{
  $val = "<td align=\"right\">$tdin</td>\n";
  return $val;
}
function tdtbl($tdwidth, $tdcolor, $intd)   // return advenced html td with width and bgcolor specified.
{
  $val = "<td width=\"$tdwidth\" BGCOLOR=\"$tdcolor\">$intd</TD>\n";
  return $val;
}

function endtbl()
{
  $val = "</tr></table>\n";
  return $val;
}

function liens($url,$target,$on)      // return html link where on text of link.
{
  $val = "<A HREF=\"$url\"";
  if ($target == "0")
    {
      $val .= ">$on</A>\n";
    }
  else
    {
      $val .= " TARGET=\"$target\">$on</A>\n";
    }
  return $val;
}

function newsdbtbl($width,$first_tcolor,$sec_tcolor,$contenu,$epaisseur,$titre,$titre_color) // return html double table table with all there params. if width = 0 ==> auto width.
{
  if($width == "0")
  {
      $val = "<TABLE BGCOLOR=\"#000000\" CELLPADDING=\"0\" CELLSPACING=\"0\" BORDER=\"0\">\n";
  }
  else
  {
      $val = "<TABLE BGCOLOR=\"#000000\" CELLPADDING=\"0\" CELLSPACING=\"0\" BORDER=\"0\" WIDTH=\"$width\">\n";
  }
  $val .= "<TR>\n";
  $val .= "<TD WIDTH=\"100%\" VALIGN=\"top\">\n";
  $val .= "   <TABLE CELLPADDING=\"$epaisseur\" CELLSPACING=\"$epaisseur\" BORDER=\"0\" WIDTH=\"100%\">\n";
  $val .= "   <TR>\n";
  $val .= "   <TD NOWRAP ALIGN=\"CENTER\" BGCOLOR=\"$first_tcolor\">\n";
  $val .= "   <FONT COLOR=\"$titre_color\"><CENTER><B>$titre</B></CENTER></FONT>\n";
  $val .= "   </TD></TR>\n";
  $val .= "   <TR>\n";
  $val .= "   <TD WIDTH=\"100%\" VALIGN=\"top\" BGCOLOR=\"$sec_tcolor\">\n";
  $val .= "   $contenu\n";
  $val .= "   </TD>\n";
  $val .= "   </TR>\n";
  $val .= "   </TABLE>\n</TD>\n</TR>\n</TABLE>\n";
  return $val;
}

function center($info)  // return centered information passed.
{
  $val = "<CENTER>\n$info</CENTER>\n";
  return $val;
}

function font_color($color,$contenu)  // return information with font color passed.
{
  $val = "<FONT FACE=\"helvetica,arial\" COLOR=\"$color\">$contenu</FONT>\n";
  return $val;
}

function confirm_msg($msg)  // return colored warning msg.
{
    return("<FONT FACE=\"Arial,Helvetica\" COLOR=\"#6611FF\">$msg</FONT>");
}

function form_select($nom,$values) // return a select field whith all values name passe in array: $values
{
        if(gettype($values)=="array")
        {
                $val = "<SELECT NAME=\"$nom\">\n";
                // bug in array fonction.
                $val .= "<OPTION>0</OPTION>\n";
                while($vname = array_shift($values))
                {
                        $val .= "<OPTION>$vname</OPTION>\n";
                }
                $val .= "</SELECT>\n";
        }
        else
        {
                $val = $values;
        }
        return($val);
}

?>