<?
/*   $id: $
This script is part of the SLIS Project initiated by the CARMI-Internet (Acadmie de Grenoble - France 38).
Ce script fait partie du projet SLIS dmarr par le CARMI-Internet (Acadmie de Grenoble - France 38).

This script have been write by Julien Dumont - copyright (C) 2001
Ce script  t crit par Julien Dumont - copyright (C) - 2001

SLIS : Serveur de communications Linux pour l'Internet Scolaire. Copyright (C) 1998-2001 Bruno Bzeznik

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details. You should have received a copy of the GNU General Public License along with this program (For example ./COPYING);
if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please send all comments and bug reports by electronic mail to: <slis@ac-grenoble.fr>
Envoyez vos suggestions et reports de bugs par e-mail  Bruno Bzeznik <slis@ac-grenoble.fr>
*/

function users_fields_select($name) // return an html select named $named whith all posiblilite of users's importing fields and their values.
{
    require("../../slis.conf.php");
    require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now

    $val = "<select name=$name>";
    $val .= "<option value=nom>$lang_Name</option>";
    $val .= "<option value=prenom>$lang_Surename</option>";
    $val .= "<option value=classe>$lang_Group</option>";
    $val .= "<option value=login>$lang_Login</option>";
    $val .= "<option value=code>$lang_Student_code</option>";
    $val .= "<option value=passwd>$lang_Password</option>";
    $val .= " <option value=empty selected>$lang_Nothing</option>";
    $val .= "</select>";
    return($val);
}

function check_users_import_params($first,$second,$third,$for,$five,$six) // return param's table or error msg.
{
    require("../../slis.conf.php");
    require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now
    if($first != "empty")
    {
        $params[0] = $first;
    }
    else
    {
        return("$lang_errormsg_1");
    }
    if($second != "empty")
    {
        $params[1] = $second;
    }
    else
    {
        return("$lang_errormsg_1");
    }
    if ($third != "empty")
    {
        $params[2] = $third;
    }
    else // check if it's name and surename.
    {
        if(!(  (($params[0] == "prenom") || ($params[1] == "prenom")) && (($params[0] == "nom") || ($params[1] == "nom")) && ($params[0] != $params[1])  ))
        {
              return("$lang_errormsg_2");
        }
        else
        {
            return($params);
        }
    }
    if($for != "empty")
    {
        $params[3] = $for;
    }
    else // check if it's name and surename
    {
        if(!(  ( ($params[0] == "prenom") || ($params[1] == "prenom") || ($params[2] == "prenom") ) && ( ($params[0] == "nom") || ($params[1] == "nom") || ($params[2] == "nom") ) && ( ($params[0] != $params[1]) && ($params[1] != $params[2]) && ($params[0] != $params[2] ) )  ))
        {
              return("$lang_errormsg_3");
        }
        else
        {
            return($params);
        }
    }
    if($five != "empty")
    {
      $params[4] = $five;
    }
    else
    {
        if(!(  ( ($params[0] == "prenom") || ($params[1] == "prenom") || ($params[2] == "prenom") || ($params[3] == "prenom") ) && ( ($params[0] == "nom") || ($params[1] == "nom") || ($params[2] == "nom") || ($params[3] == "nom") ) && ( ($params[0] != $params[1]) && ($params[1] != $params[2]) && ($params[0] != $params[2] ) && ($params[2] != $params[3]) && ($params[1] != $params[3]) && ($params[0] != $params[3]) )  ))
        {
             return("$lang_errormsg_3");
        }
        else
        {
            return($params);
        }
    }
    if($six != "empty")
    {
        $params[5] = $six;
        if(!(  ( ($params[0] == "prenom") || ($params[1] == "prenom") || ($params[2] == "prenom") || ($params[3] == "prenom") || ($params[4] == "prenom") || ($params[5] == "prenom") ) && ( ($params[0] == "nom") || ($params[1] == "nom") || ($params[2] == "nom") || ($params[3] == "nom") || ($params[4] == "nom") || ($params[5] == "nom") ) && ( ($params[0] != $params[1]) && ($params[1] != $params[2]) && ($params[0] != $params[2] ) && ($params[2] != $params[3]) && ($params[1] != $params[3]) && ($params[0] != $params[3]) && ($params[3] != $params[4]) && ($params[0] != $params[4]) && ($params[1] != $params[4]) && ($params[2] != $params[4])  && ($params[0] != $params[5]) && ($params[1] != $params[5]) && ($params[2] != $params[5]) && ($params[3] != $params[5]) && ($params[4] != $params[5]) ) ) )
        {
              return("$lang_errormsg_3");
        }
    }
    else
    {
        if(!(  ( ($params[0] == "prenom") || ($params[1] == "prenom") || ($params[2] == "prenom") || ($params[3] == "prenom") || ($params[4] == "prenom") ) && ( ($params[0] == "nom") || ($params[1] == "nom") || ($params[2] == "nom") || ($params[3] == "nom") || ($params[4] == "nom") ) && ( ($params[0] != $params[1]) && ($params[1] != $params[2]) && ($params[0] != $params[2] ) && ($params[2] != $params[3]) && ($params[1] != $params[3]) && ($params[0] != $params[3]) && ($params[3] != $params[4]) && ($params[0] != $params[4]) && ($params[1] != $params[4]) && ($params[2] != $params[4])  )  ))
        {
              return("$lang_errormsg_3");
        }
        else
        {
            return($params);
        }
    }
    return($params);
}

function buildquery($first,$second,$third,$for,$five,$six,$values,$db)     // A FINIR
{
    require("../../slis.conf.php");
    require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now

    if( ($first == "login") || ($second == "login") || ($third == "login") || ($for == "login") || ($five == "login") || ($six == "login") )  // check if we must make a login.
    {
        $have_login = 1;
    }
    else
    {
        $have_login = 0;
    }
    $nb_params = count($values);
    if( ($nb_params == 2) && ($have_login == 0) )     // we have just name and surname.
    {
         if($first == "nom")
         {
              $Nom = $values[0];
              $Prenom = $values[1];
         }
         else
         {
              $Prenom = OterSpace($values[0]);
              $Nom = OterSpace($values[1]);
         }
         $pass = makepass();
         $login = mklogin($Nom,$Prenom,$db);

         /* sql */
         $query = "insert into \"users\" (nom,prenom,login,passwd,modif,nouveau,delete,tovalid) VALUES ('$Nom','$Prenom','$login','$pass','0','1','0','1');";
         $v_query = pg_exec($db,$query);

         if($v_query)
         {
              /* get user id */
              $userid = get_userid($db,$login);

              /* add encrypt passwd */
              $passmd5 = makemd5($pass);
              $passcrypt = makecrypt($pass);
              $querypass = "insert into \"password\" (id,md5,crypt) VALUES ('$userid','$passmd5','$passcrypt');";
              $v_querypass = pg_exec($db,$querypass);

              /* make user first alias */
              $alias =  make_alias($Nom,$Prenom);
              $checkalias = add_alias($db,$alias,$userid);
         }
         if($v_query)    // $val must return result.
         {
            $val = "$lang_User : $Nom $Prenom <b>$lang_create</b>";
         }
         else
         {
            $val = "$lang_User : $Nom $Prenom <b>$lang_nocreate</b>";
         }
    }
    elseif(!($nb_params == 2))  // we recheck if they have no error in params enter.
    {
        $query1 = getparamsquery($db,$first,$second,$third,$for,$five,$six,$values); //return array with query[0] and alias[1] and login[3] and code[4];
        $pass = get_params_passwd($first,$second,$third,$for,$five,$six,$values); // return pass if one is give in params or make one if we haven't
        $passmd5 = makemd5($pass);
        $passcrypt = makecrypt($pass);
        $class = have_params_class($db,$first,$second,$third,$for,$five,$six,$values); //return classid if one enter (create it if not existe) or 0 if none.

        /* check user login */
        $check_login = check_login($db,$query1[3]);
        $check_code = check_code($db,$query1[4]);
        if( ($check_login == "ok") && ($check_code == "ok") )
        {
            /* sql */
            $v_query = pg_exec($db,$query1[0]); // faire un check login avant d'executer la query.
            if($v_query)
            {
                /* get user id */
                $userid = get_userid($db,$query1[3]);

                /* add encrypt passwd */
                $querypass = "insert into \"password\" (id,md5,crypt) VALUES ('$userid','$passmd5','$passcrypt');";
                $v_querypass = pg_exec($db,$querypass);

                /* make user first alias */
                $alias =  $query1[1];
                $checkalias = add_alias($db,$alias,$userid);
                if($class != 0) // we must add affectation in groups.
                {
                    $check = add_primary_class($db,$userid,$class); // add primary class
                }
                if($v_query)
                {
                    $username = get_name($db,$userid);
                    $val = "$lang_User : $username <b>$lang_create</b>";
                }
                else
                {
                    $val = "$lang_User : $username ".errormsg("$lang_One_error_append.");
                }
            }
        }
        elseif($check_login != "ok")
        {
             if($check_login = "already")
             {
                  $val = "$lang_User : $query1[1] ".errormsg("$query1[3] : $lang_error_login_in_use.");
             }
             elseif($check_login = "failed")
             {
                  $val = "$lang_User : $query1[1] ".errormsg("$query1[3] : $lang_Impossible_login.");
             }
             elseif($check_login = "bad")
             {
                $val = "$lang_User : $query1[1] ".errormsg("$query1[3] :  $lang_Login_bad_caracters");
             }
        }
        else
        {
             $val = "$lang_User : $query1[1] ".errormsg("$query1[4] : $lang_Impossible_code.");
        }
    }
    else
    {
        $val = "$lang_User : $query1[1] ".errormsg("$lang_One_error_append.");
    }
    return("<CENTER>$val</CENTER>\n");
}

function have_params_class($db,$first,$second,$third,$for,$five,$six,$values) //return classid if one enter (create it if not existe) or 0 if none.
{
   $class = 0; // initalize checker.
   if($first == "classe")
   {
      $classe = $values[0];
      $class = 1;
   }
   if($second == "classe")
   {
      $classe = $values[1];
      $class = 1;
   }
   if($third == "classe")
   {
      $classe = $values[2];
      $class = 1;
   }
   if($for == "classe")
   {
      $classe = $values[3];
      $class = 1;
   }
   if($five == "classe")
   {
      $classe = $values[4];
      $class = 1;
   }
   if($six == "classe")
   {
      $classe = $values[5];
      $class = 1;
   }
   if($class == 0) // we don't have params class
   {
       $val = 0;
   }
   else // we have classe params.
   {
      $check = get_class_id($db,$classe);
      if($check != 0)
      {
          $val = $check;
      }
      else  // we must create the class $classe
      {
          $check2 = add_classe($classe,$db);
          if(ereg("sera",$check2))
          {
              $val = get_class_id($db,$classe);
          }
          else // error in when create class: system reserved name.
          {
              print errormsg($check2);
              exit;
          }
      }
   }
   return ($val);
}

function getparamsquery($db,$first,$second,$third,$for,$five,$six,$value)  //return sql query formated [0] and alias [1] and login [3];
{
   $val1 = "INSERT INTO users ("; // start of query
   $val2 = "VALUES ("; // start value of first query.
   $before = 0; // check for quote
   if(($first != "classe") && ($first != "empty") && ($first != "passwd"))
   {
        $val1 .= "$first";
        $val2 .= "'$value[0]'";
        $before = 1;
        if($first == "login")
        {
            $login = $value[0];
        }
        if($first == "code")
        {
            $code = $value[0];
        }
   }
   if(($second != "classe") && ($second != "empty") && ($second != "passwd"))
   {
        if($before == 1)
        {
           $val1 .= ",";
           $val2 .= ",";
        }
        $val1 .= "$second";
        $val2 .= "'$value[1]'";
        $before = 1;
        if($second == "login")
        {
            $login = $value[1];
        }
        if($second == "code")
        {
            $code = $value[1];
        }
   }
   if(($third != "classe") && ($third != "empty") && ($third != "passwd"))
   {
        if($before == 1)
        {
           $val1 .= ",";
           $val2 .= ",";
        }
        $val1 .= "$third";
        $val2 .= "'$value[2]'";
        $before = 1;
        if($third == "login")
        {
            $login = $value[2];
        }
        if($third == "code")
        {
            $code = $value[2];
        }
   }
   if(($for != "classe") && ($for != "empty") && ($for != "passwd"))
   {
        if($before == 1)
        {
           $val1 .= ",";
           $val2 .= ",";
        }
        $val1 .= "$for";
        $val2 .= "'$value[3]'";
        $before = 1;
        if($for == "login")
        {
            $login = $value[3];
        }
        if($for == "code")
        {
            $code = $value[3];
        }
   }
   if(($five != "classe") && ($five != "empty") && ($five != "passwd"))
   {
        if($before == 1)
        {
           $val1 .= ",";
           $val2 .= ",";
        }
        $val1 .= "$five";
        $val2 .= "'$value[4]'";
        $before = 1;
        if($five == "login")
        {
            $login = $value[4];
        }
        if($five == "code")
        {
            $code = $value[4];
        }
   }
   if(($six != "classe") && ($six != "empty") && ($six != "passwd"))
   {
        if($before == 1)
        {
           $val1 .= ",";
           $val2 .= ",";
        }
        $val1 .= "$six";
        $val2 .= "'$value[5]'";
        $before = 1;
        if($six == "login")
        {
            $login = $value[5];
        }
        if($six == "code")
        {
            $code = $value[5];
        }
   }
   $password = get_params_passwd($first,$second,$third,$for,$five,$six,$value); // make passwd
   $endquery=params_have_login($db,$first,$second,$third,$for,$five,$six,$value); //check if we have to complete query with login or no.
   if($endquery[0] != 1)
   {
      $val1 .= ",login";
      $val2 .= ",'$endquery[0]'";
      $login = $endquery[0];
   }
   $val1 .= ",passwd,modif,nouveau,delete,tovalid)";
   $val2 .=",'$password','0','1','0','1')";

   // return.

   $val[0] = "$val1 $val2 ;";
   $val[1] = $endquery[1]; // alias
   $val[3] = $login; //login;
   $val[4] = $code; // student code
   return($val);
}

function get_params_passwd($first,$second,$third,$for,$five,$six,$values)  // return pass if one is give in params or make one if we haven't.
{
   $pass = 0; // initalize checker.
   if($first == "passwd")
   {
      $passwd = $values[0];
      $pass = 1;
   }
   if($second == "passwd")
   {
      $passwd = $values[1];
      $pass = 1;
   }
   if($third == "passwd")
   {
      $passwd = $values[2];
      $pass = 1;
   }
   if($for == "passwd")
   {
      $passwd = $values[3];
      $pass = 1;
   }
   if($five == "passwd")
   {
      $passwd = $values[4];
      $pass = 1;
   }
   if($six == "passwd")
   {
      $passwd = $values[5];
      $pass = 1;
   }
   if($pass == 0) // make passwd because we don't have.
   {
      $passwd=  makepass();
   }
   return ($passwd);
}

function params_have_login($db,$first,$second,$third,$for,$five,$six,$values) // return [0]=1 and [1]=alias if param login found or newlogin[0] end alias[1].
{
   $login = 0; // initalize checker.
   if($first == "login")
   {
      $login = 1;
   }
   if($second == "login")
   {
      $login = 1;
   }
   if($third == "login")
   {
      $login = 1;
   }
   if($for == "login")
   {
      $login = 1;
   }
   if($five == "login")
   {
      $login = 1;
   }
   if($six == "login")
   {
      $login = 1;
   }
   if($first = "nom")
   {
      $nom = $values[0];
   }
   elseif($second == "nom")
   {
      $nom = $values[1];
   }
   elseif($third == "nom")
   {
      $nom = $values[2];
   }
   elseif($for == "nom")
   {
      $nom = $values[3];
   }
   elseif($five == "nom")
   {
      $nom = $values[4];
   }
   elseif($six == "nom")
   {
      $nom = $values[5];
   }

   if($first == "prenom")
   {
      $prenom = $values[0];
   }
   elseif($second == "prenom")
   {
      $prenom = $values[1];
   }
   elseif($third == "prenom")
   {
      $prenom = $values[2];
   }
   elseif($for == "prenom")
   {
      $prenom = $values[3];
   }
   elseif($five == "prenom")
   {
      $prenom = $values[4];
   }
   elseif($six == "prenom")
   {
      $prenom = $values[5];
   }
   if($login != 1) // make login because we don't have.
   {
      $login = mklogin($nom,$prenom,$db);
   }
   if($login == 1)
   {
      $val[0] = 1;
      $val[1] = "$nom.$prenom";
   }
   else
   {
      $val[0] = $login;
      $val[1] = "$nom.$prenom";
   }
   return($val);
}

function import($texte,$separator,$first,$second,$third,$for,$five,$six,$db)
{
    require("../../slis.conf.php");
    require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now
    require("../inc/themes.inc.php");
    $params = check_users_import_params($first,$second,$third,$for,$five,$six);
     if( gettype($params) != "array")
     {
          $contenu = errormsg("$params").center("<B><A HREF=\"./?mode=gep\">$lang_REDO.</A></B><br><br>");
          $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_Status,$titre_color);
          $val = center($val);
          $val = saut(2)."$val";
          print "$val\n";
          exit;
     }
     else
     {
          $nb_arguments = count($params);  // nomber of params in array for build dynamicly the requette. and for made check.
     }
     $text = split("\n", $texte);
     while($ligne = array_shift($text))
     {
         $ligne = chop($ligne); // remove  \n
         $values = split("$separator",$ligne);
         if( count($values) != $nb_arguments) // ligne error : number of parameters is not the same that in user choice of import.
         {
              $contenu = errormsg("$lang_bad_import_format.").center("<B><A HREF=\"./?mode=gep\">$lang_REDO.</A></B><br><br>");
              $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_Status,$titre_color);
              $val = center($val);
              $val = saut(2)."$val";
              print "$val\n";
              exit;
         }
         $result = buildquery($first,$second,$third,$for,$five,$six,$values,$db);
         $val .= "$result<br>\n";
     }
     return($val);
}


?>