<?
/*
This script is part of the SLIS Project initiated by the CARMI-Internet (Acadmie de Grenoble - France 38).
Ce script fait partie du projet SLIS dmarr par le CARMI-Internet (Acadmie de Grenoble - France 38).

This script have been write by Julien Dumont - copyright (C) 2001
Ce script  t crit par Julien Dumont - copyright (C) - 2001

SLIS : Serveur de communications Linux pour l'Internet Scolaire. Copyright (C) 1998-2001 Bruno Bzeznik

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details. You should have received a copy of the GNU General Public License along with this program (For example ./COPYING);
if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please send all comments and bug reports by electronic mail to: <slis@ac-grenoble.fr>
Envoyez vos suggestions et reports de bugs par e-mail  Bruno Bzeznik <slis@ac-grenoble.fr>
*/

// tools and libs
require("../inc/pgsql.inc.php");
require("../inc/html.inc.php");
require("../inc/lib.inc.php");


// connection sql
$db = dbconnect();

//loading html part
$starthtml = startHTML("$lang_User_changes");
$end = endHTML();

//html header output
print $starthtml;

if($mod == "muser") // account changes.
{
   if($userid)
   {
      if( (($Nom) && ($Nom != "")) && (($Prenom) && ($Prenom != "")) )
      {
          /* update of primary class  param */
          $is_pclass = is_primary_class($db,$userid,$class);
          if( ($class) && ($class != "000") && ($is_pclass != 1) ) 
          {
              // add new primary
              $check = add_primary_class($db,$userid,$class);
          }

          /* sql */
          $check = save_oldvalue($db,$userid); // save old value for cancel.
          if($check == "ok")
          {
              $check_user_code = check_user_code($db,$code,$userid); // look if user has already this code.
              if( ($code) && ($check_user_code == "0") )
              {
                  $check_code = check_code($db,$code);
                  if($check_code == "ok")
                  {
                      $query = "update \"users\" set nom='$Nom',prenom='$Prenom',code='$code',infos='$infos',modif='Yes',tovalid='Yes' where id='$userid' ;";
                  }
                  else
                  {
                      $contenu = errormsg("$code : $lang_Impossible_code.");
                      $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,"$lang_Status",$titre_color);
                      $val = center($val);
                      $val = saut(2)."$val";
                      print "$val";
                      exit;
                  }
              }
             else
             {
                $query = "update \"users\" set nom='$Nom',prenom='$Prenom',infos='$infos',modif='Yes',tovalid='Yes' where id='$userid' ;";
             }
             $v_query = pg_exec($db,$query);
          }
          else
          {
              $contenu = errormsg("$lang_save_error.");
          }
          if($newpass == 1) // remake passwd
          {
              $contenu = "<br><FONT FACE=\"Helvetica,Arial\">\n<CENTER><H3><I><font color=\"#ff0000\">$lang_WARNING</font>\n</I></H3><P>$lang_Nocancel_action.<P>\n<B><A HREF=\"./update.php?mod=passwd&userid=$userid\">$lang_next</A></B>\n</FONT><br><br>\n";
              // advertise that we can't cancel.
          }
          // confirmation
          if(($v_query) && ($newpass != 1))
          {
              $contenu = "<br><FONT FACE=\"Helvetica,Arial\">\n<CENTER><H3><I>$lang_record_infos\n</I></H3><P>$lang_valid_modifs.<P>\n<B><A HREF=\"./?mode=view\">$lang_Change_another_account</A></B>\n</FONT><br><br>\n";
          }
      }
      else
      {
          $contenu = errormsg("$lang_error_name_surename<BR><A HREF=\"./edit.php?mod=user&update=yes&userid=$userid&Nom=$Nom&Prenom=$Prenom&code=$code&class=$class&infos=$infos\">$lang_REDO.</A>");
      }
   }
   else // we don't have userid
   {
      $contenu = "<br><FONT FACE=\"Helvetica,Arial\">\n<CENTER><H3><I>$lang_IMPORTANTE_ERROR</I></H3></CENTER><BR>\n".errormsg("$lang_MISS_USERID.")."<br><br>";
   }
   $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,"$lang_Status",$titre_color);
   $val = center($val);
   $val = saut(2)."$val";
   print "$val";
}
elseif($mod == "passwd") // remake passwd
{
   $check = remake_passwd($db,$userid);
   $username = get_name($db,$userid);
   if($check = 1)
   {
      $contenu = "<br><FONT FACE=\"Helvetica,Arial\">\n<CENTER><H3><I>".confirm_msg("$lang_User $username --> $lang_password $lang_remaked")."\n</I></H3><P>$lang_Valid_for_active_changes<P>\n<B><A HREF=\"./?mode=view\">$lang_Back</A></B>\n</FONT><br><br>\n";
   }
   else
   {
      $contenu = errormsg("$lang_remakepass_error");
   }
   $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,"$lang_Status",$titre_color);
   $val = center($val);
   $val = saut(2)."$val";
   print "$val";
}
elseif($mod == "classe") // class changes
{
   if( (($classeid) && ($classeid != "")) && (($class) && ($class != "")) )
   {
      /* sql */
      $check = save_oldvalue($db,$classeid); // save old value for cancel.
      if($check == "ok")
      {
          $query = "update \"classes\" set nom='$class',modif='Yes',tovalid='Yes' where id='$classeid' ;";
          // debug print $query;
          $v_query = pg_exec($db,$query);
      }
      // message de confirmation
      if($v_query)
      {
         $contenu = "<br><FONT FACE=\"Helvetica,Arial\"><CENTER><H3><I>".confirm_msg("$lang_Group $class --> $lang_modifed")."\n</I></H3><P>$lang_Valid_for_active_changes<P>\n<B><A HREF=\"./?mode=view\">$lang_Back</A></B><br><br></FONT>\n";
      }
      else
      {
          $contenu = errormsg("$lang_error_miss_NAME<BR><A HREF=\"./edit.php?mod=classe&update=yes&classename=$class\">$lang_REDO.</A>");
      }
   }
   else
   {
      $contenu = errormsg("<br>$lang_error_miss_NAME<P><A HREF=\"./edit.php?mod=classe&update=yes&classename=$class\">$lang_REDO.</A><br>");
   }
   $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,"$lang_Status",$titre_color);
   $val = center($val);
   $val = saut(2)."$val";
   print "$val";
}
else
{
    print "<P><CENTER><A HREF=\"./\">$lang_BACK</A></CENTER>\n";
}


// end of page
print $end;

//close sql
pg_close($db);
?>